#include "P1.c"

int main()
{
  Wait_Queue Customer_Wait_Queue = {0,0,NULL,NULL};
  Wait_Node_Pointer Ptr_Head = NULL;
  Wait_Node_Pointer Ptr_Tail = NULL;
  Customer_Pointer Ptr_Customer = NULL;
  Customer_Pointer Ptr_Customer_2 = NULL;

  Customer_Wait_Queue.Ptr_Head = Ptr_Head;
  Customer_Wait_Queue.Ptr_Tail = Ptr_Tail;
  Customer_Wait_Queue.Wait_Queue_Length = 0;
  Customer_Wait_Queue.Wait_Items_In_Queue = 0;

  Ptr_Customer = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));
  
  if (Ptr_Customer == NULL)
  {
    exit ERROR_DETECTED;
  }  

  Ptr_Customer->Customer_Number = 5;
  Ptr_Customer->Time_Arrived = 3;
  Ptr_Customer->Parameters.Interarrival_Time = 3;
  Ptr_Customer->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer->Parameters.Shopping_Time = 5;
  Ptr_Customer->Parameters.Service_Time = 7;

  Insert_In_Wait_Queue (&Customer_Wait_Queue, Ptr_Customer);

  Ptr_Customer_2 = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_2 == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer_2->Customer_Number = 2;
  Ptr_Customer_2->Time_Arrived = 6;
  Ptr_Customer_2->Parameters.Interarrival_Time = 7;
  Ptr_Customer_2->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_2->Parameters.Shopping_Time = 6;
  Ptr_Customer_2->Parameters.Service_Time = 8;

  Insert_In_Wait_Queue (&Customer_Wait_Queue, Ptr_Customer_2);
 
  printf ("Insert into Customer Wait Queue:\n");
  printf ("Customer Number: %d -> %d\n",
     Customer_Wait_Queue.Ptr_Head->Ptr_Customer->Customer_Number,
     Customer_Wait_Queue.Ptr_Tail->Ptr_Customer->Customer_Number);
  printf ("Wait Queue Length: %d\n",
     Customer_Wait_Queue.Wait_Queue_Length);
  printf ("Items In Wait Queue: %d\n",
     Customer_Wait_Queue.Wait_Items_In_Queue);
  printf ("\n");

  Ptr_Customer = Remove_From_Wait_Queue (&Customer_Wait_Queue);

  printf ("After Remove from Customer Wait Queue:\n");
  printf ("Customer Number Removed: %d\n", Ptr_Customer->Customer_Number);
  printf ("\n");
  printf ("Items In Wait Queue: %d\n",
     Customer_Wait_Queue.Wait_Items_In_Queue);
  printf ("Wait Queue Length: %d\n",
     Customer_Wait_Queue.Wait_Queue_Length);
  printf ("Customer Number in Wait Queue: %d\n", 
     Customer_Wait_Queue.Ptr_Head->Ptr_Customer->Customer_Number);
  printf ("\n");

  printf ("Remove from Customer Wait Queue again\n");

  Remove_From_Wait_Queue (&Customer_Wait_Queue);

  if (Customer_Wait_Queue.Ptr_Head == NULL)
  {
    printf ("Wait Queue is empty\n");
    printf ("Items In Wait Queue: %d\n",
       Customer_Wait_Queue.Wait_Items_In_Queue);
    printf ("Wait Queue Length: %d\n",
       Customer_Wait_Queue.Wait_Queue_Length);
  }

  free (Ptr_Customer_2);
  Ptr_Customer_2 = NULL;
 
  free (Ptr_Customer);
  Ptr_Customer = NULL;

  return NO_ERRORS_DETECTED;
}

