#include "P3.h"

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <time.h>
#include <assert.h>      
#define EMPTY (-1)

void Merge_Two_List_Array (
  int Merged_Array[],
  int List_1[], int List_2[],
  int Size_List_1, int Size_List_2,
  int Size_Of_Index);                  

void P3_Cook_Kim_Array(
              int Data_Array[],
              int Array_Size)

{
/* The following program sorts an array of data, given that */
/* the array of data is to be sorted in ascending order.    */
/* For descending order, the code must undergo a few        */
/* altercations.                                            */


int Array_Cnt = 0;
int Good_Cnt = 0;
int Bad_Cnt = 0;
int *Good_Array = 0;
int *Bad_Array = 0;

printf("zero\n");
fflush(stdout);

Good_Array = malloc(sizeof(int)*Array_Size);
Bad_Array = malloc(sizeof(int)*Array_Size);

printf("one\n");
fflush(stdout);

while( Array_Cnt < Array_Size )
{
  if((Array_Size - Array_Cnt) == 1)
  {
    if(Data_Array[Array_Size] >= Data_Array[Array_Size-1])
     {
      Good_Array[Good_Cnt] = Data_Array[Array_Size];
      Good_Cnt++;
      Array_Size++;
     }
      else                                                                     
       {
        Bad_Array[Bad_Cnt] = Data_Array[Array_Size];
        Bad_Cnt++;
        Array_Size++;
       }
   }

printf("two\n");
fflush(stdout);

     if((Array_Size - Array_Cnt) != 1)
       {
        if(Data_Array[Array_Cnt] <= Data_Array[Array_Cnt+1])
         {
           Good_Array[Good_Cnt] = Data_Array[Array_Cnt];
           Good_Cnt++;
           Array_Cnt++;
         }

printf("three\n");
fflush(stdout);

/* Above we checked to see if the data is in good order */


       if(Data_Array[Array_Cnt] > Data_Array[Array_Cnt+1])
       {
          Bad_Array[Bad_Cnt] = Data_Array[Array_Cnt+1];
          Bad_Array[Bad_Cnt+1] = Data_Array[Array_Cnt];                        
          Bad_Cnt = Bad_Cnt + 2;
          Array_Cnt = Array_Cnt + 2;
          while(Data_Array[Array_Cnt] < Good_Array[Good_Cnt])
          {

printf("four\n");
fflush (stdout);

           Bad_Array[Bad_Cnt] = Good_Array[Good_Cnt];
           Bad_Array[Bad_Cnt+1] = Data_Array[Array_Cnt];
           Good_Cnt--;
           Array_Cnt++;
           Bad_Cnt++;
          }

       }
     }

}

printf("five\n");
fflush(stdout);

/* At the end of this portion of the function, Good_Cnt and Bad_Cnt
 * should hold the values of the lengths of the respected Arrays.
 */

     if(Bad_Cnt + 1 <= KK)
       {
/* In this case, we are to use Insertion_Sort to sort the bad data. */         

printf("six\n");
fflush(stdout);

Insertion_Sort(Bad_Array, 0, Bad_Cnt);
       }

printf("seven\n");
fflush(stdout);

    if(Bad_Cnt + 1 > KK)
       {
         Quick_MI_Sort(Bad_Array, 0, Bad_Cnt);
       }

/* Now we make the call to merge the two arrays together and
 * to overwrite the origional array.
 */

     Merge_Two_List_Array(Data_Array,
                          Good_Array,
                          Bad_Array,
                          Good_Cnt, Bad_Cnt, Array_Size);

printf("eight\n");
fflush(stdout);

     free(Good_Array);
     free(Bad_Array);

}
/* THE DATA BELOW THIS LINE IS THE SECOND PART OF THE COOK-KIM
 *                          ALGORITHIM!!
 */
void Merge_Two_List_Array (
  int Merged_Array[],
  int List_1[], int List_2[],
  int Size_List_1, int Size_List_2,
  int Size_Of_Index)
{
/*
  int *Merged_Array = NULL;
  */
  int Merged_Index = 0;
  int List1_Index = 0;
  int List2_Index = 0;

  int I = 0;

/*
  Merged_Array = (int *) malloc (Size_Of_Index * sizeof (int));
*/

printf ("\nThis is list one: ");
for (I = 0; I < Size_List_1; I++)
{
  printf ("%d ", List_1[I]);
}
printf ("\n\n");

printf ("This is list two: ");
for (I = 0; I < Size_List_2; I++)
{
  printf ("%d ", List_2[I]);
}
printf ("\n\n");

/*
  if (Merged_Array == NULL)
  {
    return;
  }
*/
  for (Merged_Index = 0; Merged_Index <= Size_Of_Index; 
    Merged_Index++)
  {
    if (    (List1_Index < Size_List_1)
         && (List2_Index < Size_List_2))
    {
      if (List_1[List1_Index] <= List_2[List2_Index])
      {
        Merged_Array[Merged_Index] = List_1[List1_Index];
        List1_Index++;
      }
      else
      {
        Merged_Array[Merged_Index] = List_2[List2_Index];
        List2_Index++;
      }
    }
    else if (    (List1_Index >= Size_List_1)
              && (List2_Index < Size_List_2))
    {
      Merged_Array[Merged_Index] = List_2[List2_Index];
      List2_Index++;      
    }
    else if (    (List1_Index < Size_List_1)
              && (List2_Index >= Size_List_2))
    {
      Merged_Array[Merged_Index] = List_1[List1_Index];
      List1_Index++; 
    } 
  }

  /*
   * Copy over the sorted array back into the original one.
   * Free the temporary space malloc-ed earlier.  
   */
/*
  for (I = 0; I < Size_Of_Index; I++)
  {
    List_1[I] = Merged_Array[I];
  }

  free (Merged_Array);
  Merged_Array = NULL;
*/

  return;
} /* Merge_Two_List_Array */






