#include "P1.c"

int main()
{
  Event_Node_Pointer Event = NULL;
  Customer_Pointer Ptr_Customer = NULL;
  Customer_Pointer Ptr_Customer_2 = NULL;
  Customer_Pointer Ptr_Customer_3 = NULL;
  Customer_Pointer Ptr_Customer_Removed = NULL;
  Events Customer_Status = Invalid;
  int Event_Time = 0;

  Ptr_Customer = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer->Customer_Number = 5;
  Ptr_Customer->Time_Arrived = 0;
  Ptr_Customer->Parameters.Interarrival_Time = 3;
  Ptr_Customer->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer->Parameters.Shopping_Time = 5;
  Ptr_Customer->Parameters.Service_Time = 7;
  
  Customer_Status = Arrived;
  Event_Time = 35;

  Insert_In_Next_Event_List(
    &Event, Event_Time, Customer_Status, Ptr_Customer);

  Ptr_Customer_2 = (Customer_Pointer) malloc
                     (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_2 == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer_2->Customer_Number = 2;
  Ptr_Customer_2->Time_Arrived = 6;
  Ptr_Customer_2->Parameters.Interarrival_Time = 7;
  Ptr_Customer_2->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_2->Parameters.Shopping_Time = 6;
  Ptr_Customer_2->Parameters.Service_Time = 8;

  Customer_Status = Departing;
  Event_Time = 30;

  Insert_In_Next_Event_List (
    &Event, Event_Time, Customer_Status, Ptr_Customer_2);

  Ptr_Customer_3 = (Customer_Pointer) malloc
                     (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_3 == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer_3->Customer_Number = 3;
  Ptr_Customer_3->Time_Arrived = 6;
  Ptr_Customer_3->Parameters.Interarrival_Time = 7;
  Ptr_Customer_3->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_3->Parameters.Shopping_Time = 6;
  Ptr_Customer_3->Parameters.Service_Time = 8;

  Event_Time = 30;
  Customer_Status = Checking_Out;

  Insert_In_Next_Event_List (
    &Event, Event_Time, Customer_Status, Ptr_Customer_3);

  printf ("Insert In Next Event List:\n");
  printf ("Customer Number: %d -> %d -> %d\n",
    Event->Ptr_Customer->Customer_Number,
    Event->Ptr_Next->Ptr_Customer->Customer_Number,
    Event->Ptr_Next->Ptr_Next->Ptr_Customer->Customer_Number);
  printf ("Customer Event Time: %d -> %d -> %d\n",
    Event->Customer_Event_Time,
    Event->Ptr_Next->Customer_Event_Time,
    Event->Ptr_Next->Ptr_Next->Customer_Event_Time);
  printf ("Customer Status: %d -> %d -> %d\n",
    Event->Customer_Status,
    Event->Ptr_Next->Customer_Status,
    Event->Ptr_Next->Ptr_Next->Customer_Status);
  printf ("\n");

  printf ("After Remove From Next Event List:\n");
  
  Ptr_Customer_Removed =  Remove_From_Next_Event_List (
                            &Event, &Event_Time, &Customer_Status);
  printf ("Customer Number: %d -> %d\n",
    Event->Ptr_Customer->Customer_Number,
    Event->Ptr_Next->Ptr_Customer->Customer_Number);
  printf ("Customer Event Time: %d -> %d\n",
    Event->Customer_Event_Time,
    Event->Ptr_Next->Customer_Event_Time);
  printf ("Customer Status: %d -> %d\n",
    Event->Customer_Status,
    Event->Ptr_Next->Customer_Status);

  printf ("Customer Number Removed From Event List: %d\n",
     Ptr_Customer_Removed->Customer_Number);
  printf ("Customer Event Time: %d\n", Event_Time);
  printf ("Customer Status: %d\n", Customer_Status);

  free (Ptr_Customer);
  Ptr_Customer = NULL;

  free (Ptr_Customer_2);
  Ptr_Customer_2 = NULL;

  free (Ptr_Customer_3);
  Ptr_Customer_3 = NULL;

  Ptr_Customer_Removed = NULL;

  return NO_ERRORS_DETECTED;
}

