#include "P1.c"

int main()
{
  Wait_Queue Customer_Wait_Queue[1] = {{0,0,NULL,NULL}};
  Wait_Node_Pointer Ptr_Head = NULL;
  Wait_Node_Pointer Ptr_Tail = NULL;
  Customer_Pointer Ptr_Customer = NULL;
  Customer_Pointer Ptr_Customer_2 = NULL;
  Customer_Pointer Ptr_Customer_3 = NULL;
  Customer_Pointer Ptr_Customer_4 = NULL;
  Event_Node_Pointer Event = NULL;
  int Event_Time = 25;
  Server_State Server_Status[1] = {Available};
  Queue_Method Queue_Method = Single_Queue;
  int Number_Of_Servers = 1;

  Customer_Wait_Queue[0].Ptr_Head = Ptr_Head;
  Customer_Wait_Queue[0].Ptr_Tail = Ptr_Tail;
  Customer_Wait_Queue[0].Wait_Queue_Length = 0;
  Customer_Wait_Queue[0].Wait_Items_In_Queue = 0;

  Ptr_Customer_4 = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_4 == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer_4->Customer_Number = 10;
  Ptr_Customer_4->Time_Arrived = 5;
  Ptr_Customer_4->Parameters.Interarrival_Time = 3;
  Ptr_Customer_4->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_4->Parameters.Shopping_Time = 7;
  Ptr_Customer_4->Parameters.Service_Time = 8;
  Ptr_Customer_4->Server = 1;

  Ptr_Customer_3 = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_3 == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer_3->Customer_Number = 6;
  Ptr_Customer_3->Time_Arrived = 5;
  Ptr_Customer_3->Parameters.Interarrival_Time = 3;
  Ptr_Customer_3->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_3->Parameters.Shopping_Time = 5;
  Ptr_Customer_3->Parameters.Service_Time = 4;
  Ptr_Customer_3->Server = 3;

  Event = (Event_Node_Pointer) malloc (sizeof(Event_Node));

  if (Event == NULL)
  {
    return ERROR_DETECTED;
  }

  Event->Customer_Event_Time = 35;
  Event->Customer_Status = Departing;
  Event->Ptr_Customer = Ptr_Customer_3;

  Ptr_Customer = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer == NULL)
  {
    return ERROR_DETECTED;
  }

  Ptr_Customer->Customer_Number = 5;
  Ptr_Customer->Time_Arrived = 3;
  Ptr_Customer->Parameters.Interarrival_Time = 3;
  Ptr_Customer->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer->Parameters.Shopping_Time = 5;
  Ptr_Customer->Parameters.Service_Time = 7;

  Insert_In_Wait_Queue (&Customer_Wait_Queue[0], Ptr_Customer);

  Ptr_Customer_2 = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_2 == NULL)
  {
    return ERROR_DETECTED;
  }

  Ptr_Customer_2->Customer_Number = 2;
  Ptr_Customer_2->Time_Arrived = 6;
  Ptr_Customer_2->Parameters.Interarrival_Time = 7;
  Ptr_Customer_2->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_2->Parameters.Shopping_Time = 6;
  Ptr_Customer_2->Parameters.Service_Time = 8;

  Insert_In_Wait_Queue (&Customer_Wait_Queue[0], Ptr_Customer_2);

  printf ("In Wait Queue:\n");
  printf ("Customer Number: %d -> %d\n",
     Customer_Wait_Queue[0].Ptr_Head->Ptr_Customer->Customer_Number,
     Customer_Wait_Queue[0].Ptr_Head->Ptr_Next->
                                  Ptr_Customer->Customer_Number);
  printf ("\n");

  printf ("In the event list:\n");
  printf ("Customer number: %d\n",
     Event->Ptr_Customer->Customer_Number);
  printf ("\n");

  printf ("Initial Event Time: %d\n", Event_Time);
  printf ("\n");

  Handle_Departing (
    Ptr_Customer_4,
    Event_Time,
    &Event,
    Customer_Wait_Queue,
    Queue_Method,
    Server_Status,
    Number_Of_Servers);

  printf ("After Handle_Departing:\n");
  printf ("Customer number departing: %d\n",
     Ptr_Customer_4->Customer_Number);
  printf ("Time departed Customer %d: %d\n",
     Ptr_Customer_4->Customer_Number,
     Ptr_Customer_4->Time_Departed);
  printf ("\n");

  printf ("Customer number in the event list: %d -> %d\n",
     Event->Ptr_Customer->Customer_Number,
     Event->Ptr_Next->Ptr_Customer->Customer_Number);
  printf ("Server for the Customer in the event list: %d -> %d\n",
     Event->Ptr_Customer->Server,
     Event->Ptr_Next->Ptr_Customer->Server);
  printf ("Customer to be served event time: %d -> %d\n",
     Event->Customer_Event_Time,
     Event->Ptr_Next->Customer_Event_Time);
  printf ("Customer to be served status in the event list: %d -> %d\n",
     Event->Customer_Status,
     Event->Ptr_Next->Customer_Status);
  printf ("Server status: %d\n", Server_Status[1]);
  printf ("\n");

  printf ("Customer number in Wait Queue after Handle_Departing: %d\n",
     Customer_Wait_Queue[0].Ptr_Head->Ptr_Customer->Customer_Number);

  free (Ptr_Customer);
  Ptr_Customer = NULL;

  free (Ptr_Customer_2);
  Ptr_Customer_2 = NULL;

  free (Ptr_Customer_3);
  Ptr_Customer_3 = NULL;

  free (Ptr_Customer_4);
  Ptr_Customer_4 = NULL;

  return NO_ERRORS_DETECTED;
}

