#include "P1.c"

int main()
{
  Event_Node_Pointer Event = NULL;
  Customer_Pointer Ptr_Customer = NULL;
  Customer_Pointer Ptr_Customer_2 = NULL;
  int Event_Time = 20;

  Event = (Event_Node_Pointer) malloc (sizeof(Event_Node));
  
  if (Event == NULL)
  {
    return ERROR_DETECTED;
  }

  Ptr_Customer = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer->Customer_Number = 5;
  Ptr_Customer->Time_Arrived = 0;
  Ptr_Customer->Parameters.Interarrival_Time = 3;
  Ptr_Customer->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer->Parameters.Shopping_Time = 5;
  Ptr_Customer->Parameters.Service_Time = 7;

  Event->Customer_Event_Time = Event_Time;
  Event->Customer_Status = Departing;
  Event->Ptr_Customer = Ptr_Customer;
  Event->Ptr_Next = NULL;

  printf ("In the Event list:\n");
  printf ("Customer number: %d\n", Event->Ptr_Customer->Customer_Number);
  printf ("Customer status: %d\n", Event->Customer_Status);
  printf ("Event time: %d\n", Event->Customer_Event_Time);
  printf ("\n"); 

  Ptr_Customer_2 = (Customer_Pointer) malloc
                   (sizeof(Customer_Simulation_Data));

  if (Ptr_Customer_2 == NULL)
  {
    exit ERROR_DETECTED;
  }

  Ptr_Customer_2->Customer_Number = 2;
  Ptr_Customer_2->Time_Arrived = 6;
  Ptr_Customer_2->Parameters.Interarrival_Time = 7;
  Ptr_Customer_2->Parameters.Number_Of_Items_Purchased = 10;
  Ptr_Customer_2->Parameters.Shopping_Time = 6;
  Ptr_Customer_2->Parameters.Service_Time = 8;

  Handle_New_Customer (Ptr_Customer_2, &Event, Event_Time);

  printf ("Inserting Customer number 2 in the Event List\n"); 
  printf ("After Handle_New_Customer: \n");
  printf ("Customer number: %d -> %d\n",
     Event->Ptr_Customer->Customer_Number,
     Event->Ptr_Next->Ptr_Customer->Customer_Number);
  printf ("Customer status: %d -> %d\n",
     Event->Customer_Status,
     Event->Ptr_Next->Customer_Status);
  printf ("Event time: %d -> %d\n",
     Event->Customer_Event_Time,
     Event->Ptr_Next->Customer_Event_Time);

  free (Ptr_Customer_2);
  Ptr_Customer_2 = NULL;

  free (Ptr_Customer);
  Ptr_Customer = NULL;

  return NO_ERRORS_DETECTED;
}

